pcl::kernel< PointT > Class Template Reference

`#include <pcl/2d/kernel.h>`

## Public Types

enum | KERNEL_ENUM { SOBEL_X, SOBEL_Y, PREWITT_X, PREWITT_Y, ROBERTS_X, ROBERTS_Y, LOG, DERIVATIVE_CENTRAL_X, DERIVATIVE_FORWARD_X, DERIVATIVE_BACKWARD_X, DERIVATIVE_CENTRAL_Y, DERIVATIVE_FORWARD_Y, DERIVATIVE_BACKWARD_Y, GAUSSIAN }
| enumerates the different types of kernels available. More...

## Public Member Functions

| kernel ()
void | fetchKernel (pcl::PointCloud< PointT > &kernel)
void | gaussianKernel (pcl::PointCloud< PointT > &kernel)
void | loGKernel (pcl::PointCloud< PointT > &kernel)
void | sobelKernelX (pcl::PointCloud< PointT > &kernel)
void | prewittKernelX (pcl::PointCloud< PointT > &kernel)
void | robertsKernelX (pcl::PointCloud< PointT > &kernel)
void | sobelKernelY (pcl::PointCloud< PointT > &kernel)
void | prewittKernelY (pcl::PointCloud< PointT > &kernel)
void | robertsKernelY (pcl::PointCloud< PointT > &kernel)
void | derivativeXCentralKernel (pcl::PointCloud< PointT > &kernel)
void | derivativeYCentralKernel (pcl::PointCloud< PointT > &kernel)
void | derivativeXForwardKernel (pcl::PointCloud< PointT > &kernel)
void | derivativeYForwardKernel (pcl::PointCloud< PointT > &kernel)
void | derivativeXBackwardKernel (pcl::PointCloud< PointT > &kernel)
void | derivativeYBackwardKernel (PointCloud< PointT > &kernel)
void | setKernelType (KERNEL_ENUM kernel_type)
void | setKernelSize (int kernel_size)
void | setKernelSigma (float kernel_sigma)

## Public Attributes

int | kernel_size_
float | sigma_
KERNEL_ENUM | kernel_type_

## Detailed Description

### template<typename PointT>
class pcl::kernel< PointT >

Definition at line 45 of file kernel.h.

## Member Enumeration Documentation

## KERNEL_ENUM

template<typename PointT>

enum pcl::kernel::KERNEL_ENUM

enumerates the different types of kernels available.

Enumerator
SOBEL_X | SOBEL_X.
SOBEL_Y | SOBEL_Y.
PREWITT_X | PREWITT_X.
PREWITT_Y | PREWITT_Y.
ROBERTS_X | ROBERTS_X.
ROBERTS_Y | ROBERTS_Y.
LOG | LOG.
DERIVATIVE_CENTRAL_X | DERIVATIVE_CENTRAL_X.
DERIVATIVE_FORWARD_X | DERIVATIVE_FORWARD_X.
DERIVATIVE_BACKWARD_X | DERIVATIVE_BACKWARD_X.
DERIVATIVE_CENTRAL_Y | DERIVATIVE_CENTRAL_Y.
DERIVATIVE_FORWARD_Y | DERIVATIVE_FORWARD_Y.
DERIVATIVE_BACKWARD_Y | DERIVATIVE_BACKWARD_Y.
GAUSSIAN | GAUSSIAN.

Definition at line 52 of file kernel.h.

## Constructor & Destructor Documentation

## kernel()

template<typename PointT>

pcl::kernel< PointT >::kernel | ( |  | ) |

inline

Definition at line 74 of file kernel.h.

## Member Function Documentation

## derivativeXBackwardKernel()

template<typename PointT>

void pcl::kernel< PointT >::derivativeXBackwardKernel | ( | pcl::PointCloud< PointT > & | kernel | ) |

Parameters

  kernel | Kernel point cloud passed by reference

kernel [-1 1 0]

Definition at line 267 of file kernel.hpp.

Referenced by pcl::kernel< PointInT >::kernel().

## derivativeXCentralKernel()

template<typename PointT>

void pcl::kernel< PointT >::derivativeXCentralKernel | ( | pcl::PointCloud< PointT > & | kernel | ) |

Parameters

  kernel | Kernel point cloud passed by reference

kernel [-1 0 1]

Definition at line 247 of file kernel.hpp.

Referenced by pcl::kernel< PointInT >::kernel().

## derivativeXForwardKernel()

template<typename PointT>

void pcl::kernel< PointT >::derivativeXForwardKernel | ( | pcl::PointCloud< PointT > & | kernel | ) |

Parameters

  kernel | Kernel point cloud passed by reference

kernel [0 -1 1]

Definition at line 257 of file kernel.hpp.

Referenced by pcl::kernel< PointInT >::kernel().

## derivativeYBackwardKernel()

template<typename PointT>

void pcl::kernel< PointT >::derivativeYBackwardKernel | ( | pcl::PointCloud< PointT > & | kernel | ) |

Parameters

  kernel | Kernel point cloud passed by reference

kernel [-1 1 0]'

Definition at line 297 of file kernel.hpp.

Referenced by pcl::kernel< PointInT >::kernel().

## derivativeYCentralKernel()

template<typename PointT>

void pcl::kernel< PointT >::derivativeYCentralKernel | ( | pcl::PointCloud< PointT > & | kernel | ) |

Parameters

  kernel | Kernel point cloud passed by reference

kernel [-1 0 1]'

Definition at line 277 of file kernel.hpp.

Referenced by pcl::kernel< PointInT >::kernel().

## derivativeYForwardKernel()

template<typename PointT>

void pcl::kernel< PointT >::derivativeYForwardKernel | ( | pcl::PointCloud< PointT > & | kernel | ) |

Parameters

  kernel | Kernel point cloud passed by reference

kernel [0 -1 1]'

Definition at line 287 of file kernel.hpp.

Referenced by pcl::kernel< PointInT >::kernel().

## fetchKernel()

template<typename PointT>

void pcl::kernel< PointT >::fetchKernel | ( | pcl::PointCloud< PointT > & | kernel | ) |

Parameters

  kernel | Kernel point cloud passed by reference

Helper function which returns the kernel selected by the kernel_type_ enum

Definition at line 43 of file kernel.hpp.

Referenced by pcl::kernel< PointInT >::kernel().

## gaussianKernel()

template<typename PointT>

void pcl::kernel< PointT >::gaussianKernel | ( | pcl::PointCloud< PointT > & | kernel | ) |

Parameters

  kernel | Kernel point cloud passed by reference

Gaussian kernel with size (kernel_size_ x kernel_size_) and variance sigma_

Definition at line 122 of file kernel.hpp.

Referenced by pcl::kernel< PointInT >::kernel().

## loGKernel()

template<typename PointT>

void pcl::kernel< PointT >::loGKernel | ( | pcl::PointCloud< PointT > & | kernel | ) |

Parameters

  kernel | Kernel point cloud passed by reference

Laplacian of Gaussian kernel with size (kernel_size_ x kernel_size_) and variance sigma_

Definition at line 149 of file kernel.hpp.

Referenced by pcl::kernel< PointInT >::kernel().

## prewittKernelX()

template<typename PointT>

void pcl::kernel< PointT >::prewittKernelX | ( | pcl::PointCloud< PointT > & | kernel | ) |

Parameters

  kernel | Kernel point cloud passed by reference

3x3 Prewitt kernel in the X direction

Definition at line 190 of file kernel.hpp.

Referenced by pcl::kernel< PointInT >::kernel().

## prewittKernelY()

template<typename PointT>

void pcl::kernel< PointT >::prewittKernelY | ( | pcl::PointCloud< PointT > & | kernel | ) |

Parameters

  kernel | Kernel point cloud passed by reference

3x3 Prewitt kernel in the Y direction

Definition at line 225 of file kernel.hpp.

Referenced by pcl::kernel< PointInT >::kernel().

## robertsKernelX()

template<typename PointT>

void pcl::kernel< PointT >::robertsKernelX | ( | pcl::PointCloud< PointT > & | kernel | ) |

Parameters

  kernel | Kernel point cloud passed by reference

2x2 Roberts kernel in the X direction

Definition at line 202 of file kernel.hpp.

Referenced by pcl::kernel< PointInT >::kernel().

## robertsKernelY()

template<typename PointT>

void pcl::kernel< PointT >::robertsKernelY | ( | pcl::PointCloud< PointT > & | kernel | ) |

Parameters

  kernel | Kernel point cloud passed by reference

2x2 Roberts kernel in the Y direction

Definition at line 236 of file kernel.hpp.

Referenced by pcl::kernel< PointInT >::kernel().

## setKernelSigma()

template<typename PointT >

void pcl::kernel< PointT >::setKernelSigma | ( | float | kernel_sigma | ) |

Parameters

  kernel_sigma | variance of the Gaussian or LoG kernels.

Setter function for kernel_sigma_

Definition at line 322 of file kernel.hpp.

Referenced by pcl::kernel< PointInT >::kernel().

## setKernelSize()

template<typename PointT >

void pcl::kernel< PointT >::setKernelSize | ( | int | kernel_size | ) |

Parameters

  kernel_size | kernel of size kernel_size x kernel_size is created(LoG and Gaussian only)

Setter function for kernel_size_

Definition at line 315 of file kernel.hpp.

Referenced by pcl::kernel< PointInT >::kernel().

## setKernelType()

template<typename PointT >

void pcl::kernel< PointT >::setKernelType | ( | KERNEL_ENUM | kernel_type | ) |

Parameters

  kernel_type | enum indicating the kernel type wanted

select the kernel type.

Definition at line 308 of file kernel.hpp.

Referenced by pcl::kernel< PointInT >::kernel().

## sobelKernelX()

template<typename PointT>

void pcl::kernel< PointT >::sobelKernelX | ( | pcl::PointCloud< PointT > & | kernel | ) |

Parameters

  kernel | Kernel point cloud passed by reference

3x3 Sobel kernel in the X direction

Definition at line 178 of file kernel.hpp.

Referenced by pcl::kernel< PointInT >::kernel().

## sobelKernelY()

template<typename PointT>

void pcl::kernel< PointT >::sobelKernelY | ( | pcl::PointCloud< PointT > & | kernel | ) |

Parameters

  kernel | Kernel point cloud passed by reference

3x3 Sobel kernel in the Y direction

Definition at line 213 of file kernel.hpp.

Referenced by pcl::kernel< PointInT >::kernel().

## Member Data Documentation

## kernel_size_

template<typename PointT>

int pcl::kernel< PointT >::kernel_size_

Definition at line 70 of file kernel.h.

## kernel_type_

template<typename PointT>

KERNEL_ENUM pcl::kernel< PointT >::kernel_type_

Definition at line 72 of file kernel.h.

## sigma_

template<typename PointT>

float pcl::kernel< PointT >::sigma_

Definition at line 71 of file kernel.h.

The documentation for this class was generated from the following files:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/2d/include/pcl/2d/kernel.h
- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/2d/include/pcl/2d/impl/kernel.hpp